//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www.kamami.com
// PROJECT  : KAmodBAR Example
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple example for KAmodBAR and ZL15AVR board.
//	  ZL15AVR displays pressure read from KAmodBAR on 2x16 char display.
//
//    Settings and connections on ZL15AVR:
//
//		  Fuse bits: 0xDF 0x99
//
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        E  (LCD_CHAR/con13) - PD2 (con18)
//        RS (LCD_CHAR/con13) - PD3 (con18)
//        D4 (LCD_CHAR/con13) - PD4 (con18)
//        D5 (LCD_CHAR/con13) - PD5 (con18)
//        D6 (LCD_CHAR/con13) - PD6 (con18)
//        D7 (LCD_CHAR/con13) - PD7 (con18)
//        RW (LCD_CHAR/con13) - GND (con18)
//
//
//   Connections between ZL15AVR and KAmodBAR:
//		  Con10 (ZL15AVR) - Con4 (KAmodBAR)	
//
//******************************************************************************
// 

#define F_CPU 16000000UL
#include <stdio.h>
#include <util/delay.h>
#include "HD44780.h"
#include "mpl115a.h"

int main()
{
	char buf[32];
	double Pressure;

//	DDRA = 0;

	LCD_Initialize();
	LCD_GoTo(0,0);
	LCD_WriteText(" ***KAmodBAR***");
	LCD_GoTo(0,1);
	LCD_WriteText("    Example");
	_delay_ms(1000);
	
	if (MPL115AReadCoeffs() == MPL115A_ERROR) 
	{
		LCD_GoTo(0,1);
		LCD_WriteText("Coeffs. error!");
		while(1);				
	}

	while(1)
	{	
		if (MPL115AReadPressureAndTempADC() == MPL115A_ERROR)
		{
			LCD_GoTo(0,1);
			LCD_WriteText("ADC read error! ");
			while(1);
		}
		else
		{
			MPL115ACalculatePressure(&Pressure);
			LCD_GoTo(0,1);
			sprintf(buf, "Press. %.1f kPa ", Pressure);
			LCD_WriteText(buf);
			_delay_ms(1000);
		}
	};
}
